<?php

class ContentUtil
{
    private $content_relationships;

    public function __construct($check_db = true)
    {
        include_once dirname(__DIR__) . '/dao/content_relationships.php';

        $this->content_relationships = new HandsomeContentRelationships($check_db);
    }

    public function getReferCidList($cid)
    {
        $ids = [];
        $data = $this->content_relationships->getReferList($cid);
        foreach ($data as $item) {
            $ids[] = $item["refer_cid"];
        }
        return $ids;
    }
    public function getRelationships($cid)
    {
        $data = [];
        $data["refer_list"] = $this->content_relationships->getReferList($cid);
        $data["used_list"] = $this->content_relationships->getUsedList($cid);
        return $data;
    }
    public function referCidByCid($cid, $refer_cid)
    {
        $this->content_relationships->add($cid, $refer_cid);
    }

    public function cancelReferCidByCid($cid, $refer_cid)
    {
        $this->content_relationships->delete($cid, $refer_cid);
    }

    public function deleteCid($cid)
    {
        $this->content_relationships->delete_by_cid($cid);
        $this->content_relationships->delete_by_refer_cid($cid);
    }

    public function check()
    {
        return $this->content_relationships->check();
    }
}
