<?php

class CrossContent {
    public static function getCrossList($widget,$isLogin)
    {
        $slug = "cross";    //页面缩略名
        $limit = 3;    //调用数量
        $length = 40;    //截取长度
        $ispage = true;    //true 输出slug页面评论，false输出其它所有评论
        $isGuestbook = $ispage ? " = " : " <> ";

        $db = Typecho_Db::get();
        $options = mget();   //Typecho_Widget::widget('Widget_Options');

        $page_url = BLOG_URL_PHP.'cross.html';
        if ($widget->is('post') || $widget->is('page') ){
            $limit = 1;
        }
        $page = $db->fetchRow($db->select()->from('table.contents')
            ->where('table.contents.created < ?', $options->gmtTime)
            ->where('table.contents.slug = ?', $slug));

        $ret = <<<EOF
<div class="time_sidebar time_widget panel box-shadow-wrap-normal" role="tabpanel" id="widget-tabs-time"> 
<h5 class="font-thin time_header padder"><i data-feather="instagram"></i></i><a href="{$page_url}" class="highlightlink">时光机</a></h5>
<ul class="list-group">
EOF;

        if ($page) {
            $type = $page['type'];
            $routeExists = (NULL != Typecho_Router::get($type));
            $page['pathinfo'] = $routeExists ? Typecho_Router::url($type, $page) : '#';
            $page['permalink'] = Typecho_Common::url($page['pathinfo'], $options->index);

            $comments = $db->fetchAll($db->select()->from('table.comments')
                ->where('table.comments.status = ?', 'approved')
                ->where('table.comments.created < ?', $options->gmtTime)
                ->where('table.comments.type = ?', 'comment')
                ->where('table.comments.parent = ?', '0')
                ->where('table.comments.cid ' . $isGuestbook . ' ?', $page['cid'])
                ->order('table.comments.created', Typecho_Db::SORT_DESC)
                ->limit($limit));
            $index = 0;
            foreach ($comments AS $comment) {
                if ($index == 0){
                    Typecho_Cookie::set('latest_time_id', $comment['coid']);
                }
                $index ++;
                $content = @$comment['text'];
                $content = CommonContent::returnExceptShortCodeContent($content);
                $content = CommentContent::postCommentContent(Markdown::convert($content),$isLogin,"","","",true);
                if ($content == ""){
                    $content = _mt("点击查看详情");
                }

                $ret .= ' <li class="list-group-item"><a href="'.BLOG_URL_PHP.'cross.html">
                       <span class="clear block m-b-none words_contents">'.CommonContent::excerpt($content,$length).'<br>
                       <small class="text-muted block time_footer"><i data-feather="clock"></i>   '.Utils::formatDate($comments,$comment['created'],
                        'NATURAL').'</small>
                       </span>
                   </a></li>';
            }
        } else {
            $ret .= '<a target="_blank" href="'.BLOG_URL.'admin/write-page.php" class="list-group-item"><span class="clear block m-b-none">这是一条默认的说说，如果你看到这条动态，请去后台新建独立页面，地址填写cross,自定义模板选择时光机。具体说明请参见主题的使用攻略。<br><small class="text-muted">'.date("F jS, Y \a\t h:i a",time()+($options->timezone - idate("Z"))).'</small></span></a>';
        }

        $ret .= '</div>';
        return $ret;

    }
}
