<?php
include_once __DIR__ . '/sql.base.php';

class HandsomeContentRelationships extends SqlBase
{
    public function __construct($check_db = true)
    {
        parent::__construct("content_relationships", $check_db);
    }

    public function getReferList($cid)
    {
        $select = $this->db->select()->from('table.' . $this->db_name)->where("cid=?", $cid);
        return $this->db->fetchAll($select);
    }

    public function getUsedList($cid)
    {
        $select = $this->db->select()->from('table.' . $this->db_name)->where("refer_cid=?", $cid);
        return $this->db->fetchAll($select);
    }

    public function add($cid, $refer_cid)
    {
        return $this->db->query($this->db->insert('table.' . $this->db_name)->rows(array(
            'cid' => $cid,
            'refer_cid' => $refer_cid
        )));

    }

    // 删除cid->xxx关系
    public function delete_by_cid($cid)
    {
        $this->db->query($this->db->delete($this->table_db_name)->where('cid = ?', $cid));
    }

    // 删除xxx->refer_cid关系
    public function delete_by_refer_cid($refer_cid)
    {
        $this->db->query($this->db->delete($this->table_db_name)->where('refer_cid = ?', $refer_cid));

    }

    public function delete($cid, $refer_cid)
    {
        $this->db->query($this->db->delete($this->table_db_name)->where('cid=? and refer_cid = ?', $cid, $refer_cid));
    }

    public function check()
    {
        return $this->db_base->is_exist_table();
    }
}
